(function() {
    window.addEventListener('DOMContentLoaded', function() {
        placementId = 'uid1';
        var cont_btn = document.getElementById("cont_ins");
        var html = `<br />Press #1 - CacheAd
        <br/> Press #2- LoadAd`;
        cont_btn.innerHTML = html;
        var test = document.getElementById("test");
        if (typeof JioAds == 'undefined') return console.log('SDK NOT FOUND');

        function customDataReset() {
            var placementNode = document.getElementById(placementId);
            var dataCustomization = placementNode.getAttribute("data-customization");
            if(dataCustomization !=null){
                placementNode.innerHTML = placementNode.getAttribute("data-element");
                if(placementNode.children.length) placementNode.children[0].style.display = "none";
            }
        }
        JioAds.onAdPrepared = function(placementId, adUxType) {
            console.info('CB: onAdPrepared Ad is ready to be displayed!', placementId, adUxType);
            var placementNode = document.getElementById(placementId);
            var dataCustomization = placementNode.getAttribute("data-customization");
            if(dataCustomization !=null && dataCustomization == "get-ad-data"){
                placementNode.setAttribute(
                    "data-element",
                    placementNode.firstElementChild.outerHTML
                );
                var dataObject = JSON.parse(placementNode.getAttribute("data-object"));
                for (var key in dataObject) {
                    var targetElement = placementNode.children[0].querySelectorAll(
                        `[data-native-element=${key}]`
                    );
                    if (targetElement.length) {
                        for (var i = 0; i < targetElement.length; i++) {
                            if (targetElement[i].tagName == "IMG") {
                                targetElement[i].src = dataObject[key];
                            } else if (targetElement[i].tagName == "VIDEO") {
                                targetElement[i].src = dataObject[key];
                            } else if (targetElement[i].tagName == "BUTTON") {
                                targetElement[i].innerText += dataObject[key];
                                targetElement[i].className = "customClickButton";
                            } else {
                                targetElement[i].innerText += dataObject[key];
                            }
                        }
                    }
                }
            }
        };

        JioAds.onAdRefresh = function(placementId) {
            console.log('CB: onAdRefresh', placementId);
            customDataReset();
        }

        JioAds.onAdRender = function(placementId) {
            console.log('CB: onAdRender', placementId);
            cont_btn.style.display = 'none';
            if(document.getElementById(placementId).innerHTML == "")
                test.style.display = 'block';
        }

        JioAds.onAdMediaStart = function(placementId) {
            console.log('CB: onAdMediaStart', placementId);
            var placementNode = document.getElementById(placementId);
            var dataCustomization = placementNode.getAttribute("data-customization");
            if(dataCustomization !=null){
                placementNode.children[0].style.display = "block";
                JioAds.fireImpressionTracker(placementId);
            }
        }

        JioAds.onAdMediaEnd = function(placementId, reward) {
            console.log('CB: onAdMediaEnd', placementId);
            if(reward) console.log('Rewards Achieved ...............');
            //test.style.display = 'none';
            //cont_btn.style.display = 'block';
            //JioAds.closeAd(placementId);
        }

        JioAds.onAdClicked = function(placementId) {
            console.log('CB: onAdClicked : ', placementId);
            customDataReset();
            var placementNode = document.getElementById(placementId);
            var midroll = placementNode.getAttribute("data-ad-break-duration");
            if(!midroll){
                test.style.display = 'none';
                cont_btn.style.display = 'block';
            }
        }

        JioAds.onAdClosed = function(placementId, isVideoCompleted, reward) {
            console.log('CB: onAdClosed : '+ placementId + " isVideoCompleted: " + isVideoCompleted);
            if(reward) console.log('Rewards Achieved ...............');
            customDataReset();
            test.style.display = 'none';
            cont_btn.style.display = 'block';
        }

        JioAds.onAdSkippable = function(placementId) {
            console.log('CB: onAdSkippable', placementId);
        }

        JioAds.onAdFailedToLoad = function(placementId, options) {
            console.log('CB: onAdFailedToLoad', placementId + " " + JSON.stringify(options));
            customDataReset();
            test.style.display = 'none';
            cont_btn.style.display = 'block';
        }

        document.addEventListener('keydown', function(e) {
            if (e.defaultPrevented) { return; }
            if (e.key == '9' || e.key == 'c' || e.key == "Backspace") {
                cont_btn.style.display = 'block';
                JioAds.closeAd(placementId);
                return;
            }
            if (e.key == '1' || e.key == 'w') {
                JioAds.cacheAd(placementId);
            } else if (e.key == '2' || e.key == 'e') {
                JioAds.loadAd(placementId);
            }
        });

        JioAds.setConfiguration({
            endpoint: "jioads",
            reqType: "sit", //dev, stg, prod, sit
            //ai: "com.jio.parentkaios",
            //ifa: 'bc6b78a1-4df0-407e-9a20-88bc64907232',
            //uid: "8885249032",
            globalMetaData: {
                ag: 28,
                ci: 'mumbai',
                gn: 'M',
                pc: 400063,
                chnm: "zee5",
                screenname: "football",
                jiomoney: "games",
                jiotv: "display",
                jioplatform: "jiopages"
            },
            la: 9874543.45,
            lo: 454334.89,
            acc: 23443.89,
            gts: 787993485956,
            logLevel: "debug",
            adRequestTimeout: 6000,
            adRenderingTimeout: 5000,
        });
    });
})();